/* Renderiza solido 3D formado por poligonos */



#include <bios.h>
#include <stdio.h>
#include <conio.h>

#include "defs.h"

#include <dpmi.h>

#include "teclado.h"

#include "sr.h"

#include "solido.h"
#include "gr.h"
#include "arquivo.h"
#include "transf.h"

#include "universo.h"

#include "render.h"

#include "camera.h"

#include "apl.h"



// para calcular frames por segundo
#include <time.h>
clock_t
   stCLI = clock (),
   stCLF;
UINT
   uFRAMES = 0;



/* construtor - inicia iluminacao
**********************************************************/
CApl::CApl ()
{
   m_oRender.mAtrIlum ( 0, 0, -1 );
}



/* Executa criacao das imagens
**********************************************************/
void CApl::mExec ( char* szArq )
{
   CTeclado
      oT ( TRUE );
   CUniverso
      oUni ( szArq );
   CSolido
      oS ( (CSolido) oUni );

   //m_oTransf.mTranslada ( 0, 0, /*- DISTCP*/0, oUni );
   //m_oTransf.mEscala ( 1, 1, -1, (CSolido&) oUni );

   // objetos que serao renderizados
   m_oRender.mAtrObjeto ( oS );

   // parametros de transformacao do solido
   // direcao de observacao e direcao de deslocamento
   BYTE
      yAngXY = 0,
      yAngXZ = 0,
      yAngYZ = 0;
   float
      // posicao do observador
      fX = 0,
      fY = 0,
      fZ = 0,
      // vetor deslocamento: aponta para onde observador vai se deslocar
      fVDX = 0,
      fVDY = 0,
      fVDZ = 0;

   // sistemas de referencia
   CSR
      oSRU,              // universo
      oSRC;              // camera

   // cria imagens do solido ateh ser teclado ESC
   while ( 1 ) {

      fVDX = 0;
      fVDY = 0;
      fVDZ = 0;
      yAngXY = 0;
      yAngXZ = 0;
      yAngYZ = 0;

      // originalmente observador nao se desloca
      fVDX = fVDY = fVDZ = 0;

      // verifica se deve sair do loop
      if ( oT.mRetPress ( T_ESC ) )
         break;

      // altera parametros do SRC conforme teclado
      // teclou para cima
      if ( oT.mRetPress ( T_SOB ) || oT.mRetPress ( T_SOB + ESPECIAL ) )
         if ( oT.mRetPress ( T_ALT_E ) || oT.mRetPress ( T_ALT_D ) )
            fVDY = -1;     // teclou ALT + SOBE (deslisa para cima)
         else
            yAngYZ ++;
      // teclou para baixo
      if ( oT.mRetPress ( T_DES ) || oT.mRetPress ( T_DES + ESPECIAL ) )
         if ( oT.mRetPress ( T_ALT_E ) || oT.mRetPress ( T_ALT_D ) )
            fVDY = 1;      // teclou ALT + DESCE (deslisa para baixo)
         else
            yAngYZ --;
      // teclou para direita
      if ( oT.mRetPress ( T_DIR ) || oT.mRetPress ( T_DIR + ESPECIAL ) )
         if ( oT.mRetPress ( T_ALT_E ) || oT.mRetPress ( T_ALT_D ) )
            fVDX = 1;      // teclou ALT + DIREITA (deslisa para direita)
         else
            yAngXZ --;
      // teclou para esquerda
      if ( oT.mRetPress ( T_ESQ ) || oT.mRetPress ( T_ESQ + ESPECIAL ) )
         if ( oT.mRetPress ( T_ALT_E ) || oT.mRetPress ( T_ALT_D ) )
            fVDX = -1;     // teclou ALT + ESQUERDA (deslisa para esquerda)
         else
            yAngXZ ++;
      // teclou HOME (giro antihorario)
      if ( oT.mRetPress ( T_HOME ) || oT.mRetPress ( T_HOME + ESPECIAL ) )
         yAngXY ++;
      // teclou PGUP (giro horario)
      if ( oT.mRetPress ( T_PG_UP ) || oT.mRetPress ( T_PG_UP + ESPECIAL ) )
         yAngXY --;
      // teclou A (para frente)
      if ( oT.mRetPress ( T_A ) )
         fVDZ = -1;
      // teclou Z (para tras)
      if ( oT.mRetPress ( T_Z ) )
         fVDZ = 1;
      // exibir angulos
      if ( oT.mRetPress ( T_F2 ) ) {
         gotoxy ( 1, 1 );
         INT16
            nAngX = (INT16) ( (float) 360 / NANGS * yAngYZ ),
            nAngY = (INT16) ( (float) 360 / NANGS * yAngXZ ),
            nAngZ = (INT16) ( (float) 360 / NANGS * yAngXY );
         printf ( "Angulos:\neixo X: %d\neixo Y: %d\neixo Z: %d\n", nAngX, nAngY, nAngZ );
         oT.mRetSoltas ();
      }
      // exibir posicao da camera
      if ( oT.mRetPress ( T_F3 ) ) {
         gotoxy ( 1, 1 );
         printf ( "Posicao da camera:\nX: %f\nY: %f\nZ: %f\n", fX, fY, fZ );
         oT.mRetSoltas ();
      }

      // define nova posicao do observador
      fX -= fVDX;
      fY -= fVDY; // Se Z cresce o objeto se afasta no SRU -> inverter
      fZ += fVDZ; // no SRC eh o contrario (sistema mao esquerda).

      // transforma do sistema de referencia
      m_oTransf.mRotacionaAbs ( yAngXY, yAngXZ, yAngYZ, oSRC );

      // solido que serah exibido neste frame
      oSRC.mAplicaBase ( (CSolido&) oUni, oS );

      // opera solido:
      // translada
      m_oTransf.mTranslada ( (INT16) fX, (INT16) fY, (INT16) fZ, oS );
      // rotaciona
      oSRC.mAplicaBase ( fVDX, fVDY, fVDZ );

      // cria imagem
      m_oRender.mRenderPoligonos ( RESX2, RESY2 );

      uFRAMES ++;
   }
}



main ( INT nNumArgs, char *szArgs [] )
{
   // verifica se foi passado nome de arquivo, se nao usa nome default
   char
      szArq [ 200 ];
   if ( nNumArgs == 1 )
      strcpy ( szArq, "default" );
   else
      strcpy ( szArq, szArgs [ 1 ] );

   CApl
      *poApl = new CApl;

   // verifica se criou aplicacao, se sim executa
   if ( poApl != NULL ) {

      poApl -> mExec ( szArq );
      delete poApl;
   }
   else
      printf ( MSG_IMPOSSIVELEXECUTAR );

   // exibe mensagem final e resultado da contagem dos frames por segundo
   stCLF = clock ();
   printf ( MSG_TITULO );
   printf ( MSG_INSTRUCOES );
   printf ( MSG_TEMPO, (float) ( stCLF - stCLI ) / CLOCKS_PER_SEC, uFRAMES, (float) uFRAMES / ( (float) ( stCLF - stCLI ) / CLOCKS_PER_SEC ) );
}
