/* Funcoes de acesso a arquivos.
Diferenca para CArquivo de a2s: nao possui funcoes de leitura de arquivos
(ver a2s\arquivo.cc), possui funcao de teste para fim de arquivo.

Formato geral dos arquivos acessaveis:
arquivos de texto com sequencias de caracteres separadas por espaco(s), e/ou
ENTER(s), e/ou TAB(s). Cada uma dessas sequencias eh denominada token.
Sao possiveis comentarios dentro do corpo do arquivo separados pelos
tokens de inicio e fim de comentario que sao os mesmos do C padrao.
Os tokens de comentario sao balanceados, ou seja, somente termina a area de
comentario quando todos os tokens de abre comentarios tiverem os seus
respectivos fecha comentarios encontrados.
	Exemplos de comentarios: errado -> /*aaa  (emendados), certo -> /* aaa

Formatos de arquivos especificos suportados:

Arquivo de objeto solido (.S):
total_de_vertices     - numero que deve vir antes das secoes
total_de_poligonos    - numero que deve vir antes das secoes, apos total vert
delimitador_de_secao  - define se os valores que seguem sao ou componentes
                        x,y,z de vertices (delimitador eh "V:") ou indices de
								vertices que compoem poligonos (delimitador: "P:").
                        As secoes podem se alternar: poligonos podem usar
								vertices definidos em qualquer posicao no arquivo
								(ateh antes do vertice a ser usado ser definido),
								pode ocorrer secoes de vertices, poligonos e outras
								secoes intercaladas.
                        "C:" delimita a secao em que o valor seguinte eh uma
                        cor a ser usada nos poligonos definidos abaixo dessa
								secao. Cor default: 64. Automaticamente apos o valor
								da cor ser lido eh alterada a secao para a secao que
								estava antes de iniciar a secao de cor, a nao ser
								que um outro delimitador seja	encontrado. Essa cor
								serah a cor base do poligono, cor cujos tons serao
                        usados para definir a sua cor na hora de exibir
                        conforme a tecnica de iluminacao.
                        Secao default no arquivo se solido: "V:"
X1 Y1 Z1              - vertices se for secao de vertices
X2 Y2 Z2
...
VA VB VC VD        - poligonos se for delimitador de secao de poligonos
VE VF VG VH          (V? eh o indice de 0 a total_de_vertices - 1)
                           Obs.: OS VERTICES DEVEM ESTAR DISPOSTOS EM SENTIDO
...                        HORARIO OU ANTI-HORARIO PARA A FUNCAO DE DESENHO
                           DE POLIGONOS FUNCIONAR DIREITO, E DEVEM ESTAR EM
									SENTIDO ANTI-HORARIO PARA FUNCAO DE REMOCAO DE
									SUPERFICIES OCULTAS FUNCIONAR!!!
									(ver CGr::mAtrVrPol2D e CRender::mRetSupVisivel)

Arquivo de particao (.PAR):
total_de_particoes     - deve vir antes de qualquer outra informacao (exceto
                         comentarios).
vertice_inicial_da_particao_1   - indices do 1o. vertice da particao 1
vertice_final_da_particao_1     - indices do ultimo vertice da particao 1
vertice_inicial_da_particao_2   - indices do 1o. vertice da particao 2
vertice_final_da_particao_2     - indices do ultimo vertice da particao 2
...
C: cor poligono_inicial poligono_final - secao de cor, soh possui esses 3
                                         dados. Pode estar intercalado com
                                         particoes. Se nao for definido serah
                                         usada as cores definidas no arquivo
													  de solido.
... */



#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "defs.h"

#include "solido.h"

#include "arquivo.h"

#include "universo.h"



/* construtor - define sem arquivo corrente
**********************************************************/
CArquivo::CArquivo ()
{
   m_pfArq = NULL;
	m_szNomeArq [ 0 ] = 0;
}



/* construtor - le arquivo de CSolido
**********************************************************/
CArquivo::CArquivo ( char* szArq, CSolido& oS )
{
   m_pfArq = NULL;
	m_szNomeArq [ 0 ] = 0;
	mRetObjeto ( szArq, oS );
}



/* construtor - le arquivo de particao para CUniverso
**********************************************************/
CArquivo::CArquivo ( char* szArq, CUniverso& oU )
{
   m_pfArq = NULL;
	m_szNomeArq [ 0 ] = 0;
	mRetObjeto ( szArq, (CSolido&) oU );
	mRetObjeto ( szArq, oU );
}



/* destrutor - fecha arquivo
**********************************************************/
CArquivo::~CArquivo ()
{
	mFechaArquivo ();
}



/* Abre ou cria arquivo, adiciona extensao ao nome do arquivo e
define niveil inicial de comentarios como 0
szModo - define modo (exemplo: rt, wb). Altera variavel membro
m_pfArq com NULL se houve erro ou com ponteiro para o arquivo.
**********************************************************/
void CArquivo::mAbreArquivo ( char* szNome, char* szExt, char* szModo )
{
   // fecha arquivo atualmente aberto
   mFechaArquivo ();

   // define nivel de comentarios
	m_uNivelComento = 0;

	// adiciona extensao ao nome do arquivo
   strcpy ( m_szNomeArq, szNome );
	strcat ( m_szNomeArq, szExt );

	// tenta abrir arquivo
	if ( ( m_pfArq = fopen ( m_szNomeArq, szModo ) ) == NULL ) {
		printf ( MSG_ERROABRIRARQUIVO, m_szNomeArq );
      exit ( 1 );
   }
}



/* Fecha arquivo se ainda estiver aberto, apaga nome antigo
**********************************************************/
void CArquivo::mFechaArquivo ()
{
   // verifica se arquivo ainda estah aberto
	if ( m_pfArq != NULL ) {
		fclose ( m_pfArq );
	   m_pfArq = NULL;
		m_szNomeArq [ 0 ] = 0;  // apaga nome do arquivo antigo
   }
}



/* Le e altera parametro para token lido de arquivo como string.
Se token for comentario (/*) vai lendo tokens ateh ler o correspondente
"fecha comentario". Os simbolos de comentarios sao balanceados.
Se bAborta TRUE - sai do programa se houve erro, senao nao.
**********************************************************/
BOOL CArquivo::mRetStr ( char* szLinha, BOOL bAborta )
{
   szLinha [ 0 ] = 0;

   BOOL
   	bSai;

   // le arquivo ateh achar token que nao esteja entre comentarios
   do {

   	bSai = TRUE;

		// verifica se houve fim de comentario se sim fecha comentario
		if ( strcmp ( szLinha, "*/" ) == 0 )
         m_uNivelComento --;

      // tenta ler arquivo, se falhar sai do programa
      if ( fscanf ( m_pfArq, "%s", szLinha ) == 0 ) {

         // verifica se havia comentario aberto (possivel causa do erro)
         if ( m_uNivelComento > 0 )
	         printf ( MSG_ERROCOMENTARIOABERTO, m_uNivelComento );

         if ( bAborta )
         	exit ( 1 );
         else
	         return FALSE;
      }

		// verifica se houve fim de comentario sem inicio correnpondente
		if ( strcmp ( szLinha, "*/" ) == 0 && m_uNivelComento == 0 ) {
      	bSai = FALSE;
         printf ( MSG_AVISOFIMCOMENTO );
      }

		// verifica se houve inicio de comentario se sim abre comentario
		if ( strcmp ( szLinha, "/*" ) == 0 )
         m_uNivelComento ++;

   } while ( m_uNivelComento != 0 && bSai );

   return TRUE;
}



/* Le token de arquivo, converte para INT16 e retorna valor.
**********************************************************/
INT16 CArquivo::mRetInt ()
{
   char
   	szLinha [ 200 ];

   mRetStr ( szLinha );

  	return (INT16) atoi ( szLinha );
}



/* Le arquivo ateh encontrar um string. Termina leitura
no token a ser encontrado. return - TRUE encontrou; FALSE - nao
**********************************************************/
BOOL CArquivo::mProcuraStr ( char* szStr )
{
   char
   	szToken [ 200 ];

	// le arquivo ateh achar token procurado
   do
      // verifica se nao chegou ao fim do arquivo
     	if ( mRetStr ( szToken, FALSE ) == FALSE )
      	return FALSE;
	while ( strcmp ( szToken, szStr ) != 0 );

   return TRUE;
}



/* Carrega arquivo de vertices e poligonos que formam solido
**********************************************************/
void CArquivo::mRetObjeto ( char* szArq, CSolido& oS )
{
	// abre arquivo de dados
   mAbreArquivo ( szArq, ".s", "rt" );

   // le numero de vertices e poligonos
   UINT16
      uMaxVert = (UINT16) mRetInt (),
      uMaxPol = (UINT16) mRetInt ();

   // aloca memoria
   oS.mAlocaMemoria ( uMaxVert, uMaxPol );

    // le conjunto de vertices e poligonos
   INT16
   	nX,
      nY,
      nZ;
   UINT16
   	uV1,
      uV2,
      uV3,
		uV4;
   BYTE
   	yTipoSec = 'V',
		yCor = 64;
   for ( UINT ucArq = 0; ucArq < ( uMaxVert + uMaxPol ); ucArq ++ ) {

   	// le toquen e ve se eh numero ou delimitador de vertices ou poligonos
      char
      	szTk [ 200 ];
		mRetStr ( szTk );
      // verifica se eh delimitador de secao de vertices
      if ( strcmp ( "V:", szTk ) == 0 || strcmp ( "v:", szTk ) == 0 ) {
      	yTipoSec = 'V';
         // le primeiro x
	      nX = mRetInt ();
      }
      else
	      // verifica se eh delimitador de secao de poligonos
	      if ( strcmp ( "P:", szTk ) == 0 || strcmp ( "p:", szTk ) == 0 ) {
   	   	yTipoSec = 'P';
            // le primeiro vertice
            uV1 = (UINT16) mRetInt ();
         }
         else
	         // verifica se eh delimitador de secao de cor
	         if ( strcmp ( "C:", szTk ) == 0 || strcmp ( "c:", szTk ) == 0 ) {
               // le cor
               yCor = (BYTE) mRetInt ();
               // procura ateh inicio da proxima secao
               BOOL
               	bFim;
               do {
                  bFim = TRUE;
               	mRetStr ( szTk );
                  // verifica se nao eh nova secao de cor
			         if ( strcmp ( "C:", szTk ) == 0 || strcmp ( "c:", szTk ) == 0 ) {
                  	yCor = (BYTE) mRetInt ();
                     bFim = FALSE;
                  }
                  else
                     // secao de poligono
				         if ( strcmp ( "P:", szTk ) == 0 || strcmp ( "p:", szTk ) == 0 ) {
                     	yTipoSec = 'P';
			            	// le primeiro vertice
         				   uV1 = (UINT16) mRetInt ();
                     }
                     else
                        // secao de vertice
				            if ( strcmp ( "V:", szTk ) == 0 || strcmp ( "v:", szTk ) == 0 ) {
                     	   yTipoSec = 'V';
			            	   // le primeira componente
         				      nX = (UINT16) mRetInt ();
                        }
                        else
                        	// numero
                           if ( yTipoSec == 'V' )
					               nX = (INT16) atoi ( szTk );
                           else
					               uV1 = (UINT16) atoi ( szTk );
               } while ( ! bFim );
            }
            else
				   // se nao eh delimitador entao eh valor numerico
               // Verifica se valor numerico eh componente x,y,z ou indice de
					// vertice, para isso verifica a qual secao o valor pertence.
               if ( yTipoSec == 'V' )
					   nX = (INT16) atoi ( szTk );
               else
					   uV1 = (UINT16) atoi ( szTk );

      // le demais componentes de vertices ou indices de vertices de poligs.
      // verifica se eh secao de vertices, se sim le componentes
      if ( yTipoSec == 'V' ) {
	      nY = mRetInt ();
   	   nZ = mRetInt ();
	      oS.mAtrVertice ( nX, nY, nZ );
      }
      else {
      	// le valores como se fossem indices de vertices de poligonos
   	   uV2 = (UINT16) mRetInt ();
      	uV3 = (UINT16) mRetInt ();
	      uV4 = (UINT16) mRetInt ();
   	   oS.mAtrPoligono ( uV1, uV2, uV3, uV4, yCor );
      }
   }

   // fecha arquivo
   mFechaArquivo ();
}



/* Carrega arquivo de particoes que formam solido
**********************************************************/
void CArquivo::mRetObjeto ( char* szArq, CUniverso& oU )
{
	// abre arquivo de dados
   mAbreArquivo ( szArq, ".par", "rt" );

   // le numero de partes
   UINT16
      uMaxPa = (UINT16) mRetInt ();

   // aloca memoria
   oU.mAlocaMemoria ( uMaxPa );

    // le particoes
   UINT16
   	uIni,
      uFim;
   for ( UINT ucArq = 0; ucArq < uMaxPa; ucArq ++ ) {

   	// le toquen e ve se eh numero ou delimitador de secao de cor
      char
      	szTk [ 200 ];
		mRetStr ( szTk );
      // se eh delimitador de secao de cor, trata todas as secoes contiguas
      while ( strcmp ( "C:", szTk ) == 0 || strcmp ( "c:", szTk ) == 0 ) {

         // dados da secao de cor
      	UINT16
            uCor = (UINT16) mRetInt (),
         	uPolIni = (UINT16) mRetInt (),
         	uPolFim = (UINT16) mRetInt ();

         // altera tabela de cor dos poligonos, conforme dados da secao
         for ( UINT16 ucP = uPolIni; ucP <= uPolFim; ucP ++ )

         	* ( oU.m_payCor + ucP ) = (BYTE) uCor;

			mRetStr ( szTk );
      }

  	   uIni = (UINT16) atoi ( szTk );
    	// le valor como se fosse indice final de vertice da particao
     	uFim = (UINT16) mRetInt ();

  	   oU.mAtrParte ( uIni, uFim );
   }

   // verifica se ainda existe alguma secao de cor para ler
   while ( mProcuraStr ( "C:" ) ) {

      // dados da secao de cor
      UINT16
         uCor = (UINT16) mRetInt (),
         uPolIni = (UINT16) mRetInt (),
         uPolFim = (UINT16) mRetInt ();

      // altera tabela de cor dos poligonos, conforme dados da secao
      for ( UINT16 ucP = uPolIni; ucP <= uPolFim; ucP ++ )
         * ( oU.m_payCor + ucP ) = (BYTE) uCor;
   }

   // fecha arquivo
   mFechaArquivo ();
}
